require_relative 'treasure_trove'

module Startupgem
	class Player

		attr_accessor :health
		attr_reader :name, :found_treasures,:health

		def initialize(name,health=100)
			@name = name.capitalize
			@health = health
			@found_treasures = Hash.new(0)
		end

		def self.convert(line)
			name,health = line.split(',')
			Player.new(name,Integer(health))
		end
		
		def print_each_treasure
			@found_treasures.each do |key,value|
				treasure = Treasure.new(key,value)
				yield(treasure)
			end
		end

		def points
			@found_treasures.values.reduce(0) {|sum,t| sum + t }
			# @found_treasures.values.reduce(0,:+)
		end

		def found_treasure(treasure)
			@found_treasures[treasure.name] += treasure.points
			puts "\t#{@name} found a #{treasure.name} worth #{treasure.points} points."
			puts "\t#{@name}'s treasures: #{@found_treasures}"
		end

		def score
			@health + points.to_i
		end

		def strong?
			health >= 100
		end

		def to_s
			"\tI'm #{@name} with a health = #{@health}, points = #{points}, score = #{score}."
		end

		def blam
			@health -= 10
			puts "\t\t#{@name} got blammed!"
		end

		def w00t
			self.health += 15
			puts "\t\t#{@name} got w00ted!"
		end

		def name=(new_name)
			@name = new_name.capitalize
		end

		def <=>(other_object)
			other_object.score <=> score
		end
	end
end

if __FILE__ == $0
	player1 = Player.new("mason",1000)
	puts player1.strong?
	# player1.found_treasure(Treasure.new(:autumn,100))
	# player1.found_treasure(Treasure.new(:prontera,100))
	# yielded = []
	# player1.print_each_treasure { |treasure| yielded.push(treasure)}
	# print yielded
end
